const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const reminders = sequelize.define(
    'reminders',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

message: {
        type: DataTypes.TEXT,
      
      

      },

remind_at: {
        type: DataTypes.DATE,
      
      

      },

channel: {
        type: DataTypes.ENUM,
      
      

        values: [

"email",


"in_app"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"scheduled",


"sent",


"canceled",


"failed"

        ],

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  reminders.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.reminders.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.reminders.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.reminders.belongsTo(db.tasks, {
      as: 'task',
      foreignKey: {
        name: 'taskId',
      },
      constraints: false,
    });

    db.reminders.belongsTo(db.deals, {
      as: 'deal',
      foreignKey: {
        name: 'dealId',
      },
      constraints: false,
    });

    db.reminders.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.reminders.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.reminders.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return reminders;
};


